/*IODOC.H /* UPDATED: 05/19/2013		T. King  -- Cabin Setup         3.10               */
/* OPTO22 /* OUTPUT Offset = 22 */
/* OPTO22 /* INPUT Offset = 38 */
/*------( /* Digital		INPUT BITS  )--------------------------------------------*/
/*LABEL      BIT		DESCRIPTION                           SENSOR TYPE      */
/*----------    --	------------------------------------  -----------------*/
#define	DI_PhoneRinging     38	/* DI00 Telephone Ringing                    (IAC5 100VAC SENSE*/
#define	DI_GasBurnRunning   39	/* DI01 Gas Burner Valve On                  (IDC5 24VAC Sense)*/
#define	DI_FrigRunning      40	/* DI02 Refrigerator Compressor Running      (IDC5 From OPTO120}
/* 2+		+24VDC                                                   */
/* 2-		(xx)-[Frig Compressor Sense]------------(xx) GND         */
#define	DI_DriveArrive      41	/* DI03 Driveway Infared Sensor / Lights     (10-32VDC Sense) */
#define	DI_Input4           42	/* DI04                                     (                */
#define	DI_WellPumpRunning  43	/* DI05 Well Pump Running                    (IDC5 From OPTO230*/
/* 5+		+24VDC                                                    */
/* 5-		(YL)-[Well Pump 230V Power]---------(BK) GND             */
#define	DI_Input6   	    44	/* DI06                                    (                */	
/* 6+		+24VDC                                                   */
/* 6-		(BL)-[]----(WH) GND             */
#define	DI_DishWasherDrying 45	/* DI07 Dishwasher in DRY CYCLE              (IDC5 From OPTO120*/
/* 7+		+24VDC                                                   */
/* 7-		(RD)-[DishWasher Dry Sense]---------(BK) GND             */
#define	DI_MainFloorButton  46	/* DI08 User Button: Main Floor  (10-32VDC Sense) */
#define	DI_OfficeButton     47	/* DI09 User Button: Office       (10-32VDC Sense) */
#define	DI_OfficeThermostat 48	/* DI10 Heating Thermostat: Office            (10-32VDC Sense) */
/*11+		24 VAC L1                                                */
/*11-		(xx)-[Thermostat Contacts ]---------(  ) 24VAC L2        */
#define	DI_MainFloorTherm   49	/* DI11 Heating Thermostat: Main Floor        (10-32VDC Sense) */
/*11+		24 VAC L1                                                */
/*11-		(xx)-[Thermostat Contacts ]---------(  ) 24VAC L2        */
#define	DI12    	    66  /* DI12   (Analog A12)                                 (                */
#define	DI13    	    67	/* DI13                                    (                */
#define	DI14 	            68	/* DI14                                    (                */
#define	DI15  	            69  /* DI15                                    (                */

/*------( Analog		Inputs )--------------------------------------------------*/

/*------( Digital		OUTPUT BITS )--------------------------------------------*/
/*LABEL      BIT		DESCRIPTION                           OUTPUT TYPE      */
/*---------- --		-------------------------------------  -----------------*/

#define	DO_HeatZoneMain  22	/* DO_00 Zone Valve On: Main Floor            (12-140VAC Control)*/
/* 0+		24VAC L1                                          */
/* 0-		(xx)-[Zone Valve 24VAC Motor ]    (xx)  24VAC L2   */
#define	DO_HeatZoneOff   23	/* DO_01 Zone Valve On: Office                (12-140VAC Control*/
#define	DO_HeatZoneRec   24	/* DO_02 Zone Valve On: Recirculate           (12-140VAC Control*/
#define	DO_OAC3          25	/* DO_03 Lights Zone 1 On                     (24VDC To SS Relay*/
#define	DO_CoffeePot     26	/* DO_04                                      (24VDC To    Relay*/
#define	DO_ElecBlanket   27	/* DO_05                                      (12-140VAC Control*/
#define	DO_ClothesWash   28	/* DO_06 Clothes Washer Power On              (24VDC To    Relay*/
#define	DO_DishWash      29	/* DO_07 Dish Washer Power On                 (24VDC To    Relay*/
/* 7+		+24VDC                                             */
/* 7-		(YL)-[DishWasher Pwr On Relay]    (GN) G           */
#define	DO_CircPumpPwr   30	/* DO_08 Circulator Pump On                   (OAC5 24VAC Switch*/
#define	DO_GasBurnEnab   31	/* DO_09 Gas Burner Enable                    (OAC5 24VAC Switch*/
#define	DO_WellPumpDis   32	/* DO_10 Disable Well Pump          (24VDC Relay: Controls 240VAC*/
#define	DO_PondPumpEnab  33	/* DO_11 Enable Pond Pump           (24VDC Relay: Controls 240VAC*/
#define	DO_PlantWater    34	/* DO_12 GreenHouse Watering        (OAC5 switching 120V Valve   */
#define	DO_13            35	/* DO_13                                                         */
#define	DO_14            36	/* DO_14                                                         */
#define	DO_15            37	/* DO_15                                                         */


