/* YourDuinoStarter Example: SM State Machine Example
 - WHAT IT DOES
  - Use the SM Library to do non-blocking delays, blink LED
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
   - Uses Onboard LED13
 - V1.00 12/3/2013
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <SM.h>
/*-----( Declare Constants and Pin Numbers )-----*/
#define PIN13_LED 13
/*-----( Declare objects )-----*/
SM ThisProg(Start);
/*-----( Declare Variables )-----*/
//none

void setup()   /****** SETUP: RUNS ONCE ******/
{
  Serial.begin(115200);
  pinMode(PIN13_LED, OUTPUT);
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  EXEC(ThisProg);
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/

State Start()
{
  Serial.println("+++ Start");
  if (ThisProg.Timeout(500)) ThisProg.Set(TurnOn) ;
}
//-----------------------------------------
State TurnOn()
{
  Serial.println("ON");
  digitalWrite(PIN13_LED, HIGH);
  if (ThisProg.Timeout(500)) ThisProg.Set(TurnOff) ;
}
//-----------------------------------------
State TurnOff()
{
  Serial.println("OFF");
  digitalWrite(PIN13_LED, LOW);
  if (ThisProg.Timeout(500)) ThisProg.Set(TurnOn) ;
}

//*********( THE END )***********

