/* YourDuinoStarter Example: SM State Machine Example
 - WHAT IT DOES
  - Use the SM Library to do non-blocking delays, blink LED
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
   - Uses Onboard LED13
 - V1.00 12/3/2013
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <SM.h>
/*-----( Declare Constants and Pin Numbers )-----*/
#define PIN13_LED 13
#define FB_num_blinks 3
/*-----( Declare objects )-----*/
SM ThisProg(Start);
SM FastBlinker(FB_done);
/*-----( Declare Variables )-----*/
int  FB_count;
//none

void setup()   /****** SETUP: RUNS ONCE ******/
{
  Serial.begin(115200);
  pinMode(PIN13_LED, OUTPUT);
  FB_count = 0;
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  EXEC(ThisProg);
  EXEC(FastBlinker);  
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/

State Start()
{
  Serial.println("+++ Start");
  ThisProg.Set(TurnOn) ;
}
//-----------------------------------------
State TurnOn()
{
//  Serial.println("ON");
  digitalWrite(PIN13_LED, HIGH);
  if (ThisProg.Timeout(1000)) ThisProg.Set(TurnOff1) ;
}
//-----------------------------------------
State TurnOff1()
{
//  Serial.println("OFF");
  digitalWrite(PIN13_LED, LOW);
  if (ThisProg.Timeout(500)) ThisProg.Set(TurnOff2) ;
}

State TurnOff2()
{
  FastBlinker.Set(FB_start);
  ThisProg.Set(TurnOff3) ;  
}

State TurnOff3()
{
  if (ThisProg.Timeout(500)) ThisProg.Set(TurnOn) ;
}


//----( SECOND STATE MACHINE: FastBlinker )--------
State FB_start()
{
  Serial.println("FB Start");  
  FB_count = 0;  
  FastBlinker.Set(FB_on);
}

State FB_on()
{
//  Serial.println("FB ON");    
  digitalWrite(PIN13_LED, HIGH);
  if (FastBlinker.Timeout(25)) FastBlinker.Set(FB_counter) ;
}

State FB_counter()
{
  Serial.println("FB count");   
  FB_count ++;
  FastBlinker.Set(FB_off);  
}

State FB_off()
{
//  Serial.println("FB OFF");    
  digitalWrite(PIN13_LED, LOW);
  if (FB_count >= FB_num_blinks) FastBlinker.Set(FB_done) ;
  if (FastBlinker.Timeout(25)) FastBlinker.Set(FB_on) ;
}


State FB_done()
{

}

//*********( THE END )***********

