/* YourDuino Test Serial Response

 * potentiometers attached to analog inputs 0 and 1 
 * pushbutton attached to digital I/O 2
   terry@yourduino.com
   Based on code by Tom Igoe
*/

/*-----( Import needed libraries )-----*/
/*-----( Declare Constants and Pin Numbers )-----*/
#define digitalIN  3 //Pin for digital input
#define analogA    A0 
#define analogB    A1

/*-----( Declare objects )-----*/
/*-----( Declare Variables )-----*/
int firstSensor = 0;    // first analog sensor
int secondSensor = 0;   // second analog sensor
int thirdSensor = 0;    // digital sensor
int inByte = 0;         // incoming serial byte


void setup()   /****** SETUP: RUNS ONCE ******/
{
  Serial.begin(9600);
  Serial.println("YourDuino.com - Test of receiving digital and analog data");
  pinMode(digitalIN, INPUT); // digital sensor is on digital pin 2  
 Serial.println("Waiting for host to send a byte");  
  establishContact();  // send a byte to establish contact until receiver responds 
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
 // if we get a valid byte, read analog ins:
  if (Serial.available() > 0) 
  {
    // get incoming byte:
    inByte = Serial.read();
    
    // read first analog input, divide by 4 to make the range 0-255:
    firstSensor = analogRead(A0)/4;
    
    // delay 10ms to let the ADC recover:
    delay(10);
    
    // read second analog input, divide by 4 to make the range 0-255:
    secondSensor = analogRead(1)/4;
    // read  switch, map it to 0 or 255L
    thirdSensor = map(digitalRead(digitalIN), 0, 1, 0, 255);  
    // send sensor values:
    Serial.print(firstSensor);
    Serial.print(",");
    Serial.print(secondSensor);
    Serial.print(",");
    Serial.println(thirdSensor); ;    
  }


}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
void establishContact() 
{
  while (Serial.available() <= 0) 
  {
    Serial.print('A');   // send a capital A
    delay(2000);
  }
}

//*********( THE END )***********

