/* YourDuino.com Example Software Sketch
 DS1307 Real Time Clock test
 CONNECTIONS:
 Ground
 +5V
 -----(Arduino) (Mega) ------
 SDA  Analog A4   20
 SCL  Analog A5   21
 
 Based on: http://github.com/adafruit/RTClib
 Also see: http://www.ladyada.net/learn/breakoutplus/ds1307rtc.html
 terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <Wire.h>
#include "RTClib.h"

/*-----( Declare objects )-----*/
RTC_DS1307 RTC;

void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  Serial.begin(9600);  // Ready to print to Serial Monitor  
  delay(500);  
  Serial.println("YourDuino DS1307 RTC Test. http://yourduino.com");
 
  Wire.begin();        // Start the Wire (I2C communications)
  RTC.begin();         // Start the RTC Chip
  
 /* Set the date / time to the time this program was compiled.
    Comment this OUT, AND upload, to let the clock just run.  */ 
//  RTC.adjust(DateTime(__DATE__, __TIME__));
  
}/*--(end setup )---*/

void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{
  DateTime now = RTC.now();  //Get the current data

  Serial.print("The year is ");
  Serial.print(now.year(), DEC);
  Serial.print(" Month = ");
  Serial.print(now.month(), DEC);
  Serial.print(" Day = ");
  Serial.print(now.day(), DEC);
  Serial.print(" Time = ");
  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  Serial.print(now.second(), DEC);
  Serial.println();

  Serial.println("EXAMPLES of Other Calculations:");
 // UNIX time is often used as Timestamps 
  Serial.print("UNIX Time since midnight 1/1/1970 = ");
  Serial.print(now.unixtime());
  Serial.print(" seconds, which is ");
  Serial.print(now.unixtime() / 86400L);
  Serial.println("days");

  // calculate a date which is 7 days and 30 seconds into the future
  DateTime future (now.unixtime() + 7 * 86400L + 30);

  Serial.print(" Future Date: now + 7 Days + 30 Sec: ");
  Serial.print(future.year(), DEC);
  Serial.print('/');
  Serial.print(future.month(), DEC);
  Serial.print('/');
  Serial.print(future.day(), DEC);
  Serial.print(' ');
  Serial.print(future.hour(), DEC);
  Serial.print(':');
  Serial.print(future.minute(), DEC);
  Serial.print(':');
  Serial.print(future.second(), DEC);
  Serial.println();

  Serial.println();
  delay(3000);
}


