/* YourDuino SoftwareSerialExample1
   - Remote: Receive data, loop it back...
   - Connect this unit Pins 10, 11, Gnd
   - To other unit Pins 11,10, Gnd  (Cross over)   
   
   Questions: terry@yourduino.com 
*/

/*-----( Import needed libraries )-----*/
#include <SoftwareSerial.h>
/*-----( Declare Constants and Pin Numbers )-----*/
#define SSerialRX 10
#define SSerialTX 11
#define Pin13LED  13
/*-----( Declare objects )-----*/
SoftwareSerial mySerial(SSerialRX, SSerialTX); // RX, TX
/*-----( Declare Variables )-----*/
int byteReceived;
int byteSend;

void setup()   /****** SETUP: RUNS ONCE ******/
{
  // Start the built-in serial port, probably to Serial Monitor
  Serial.begin(9600);
  Serial.println("SerialRemote");
  pinMode(Pin13LED, OUTPUT);   
  
  // Start the software serial port, to another device
  mySerial.begin(4800);   // set the data rate 
//  mySerial.println("Hello, I am REMOTE");  

}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  //Copy input data to output  
  if (mySerial.available()) 
  {
    byteSend = mySerial.read();    
    digitalWrite(Pin13LED, HIGH);  // Show activity
    delay(100);              
    digitalWrite(Pin13LED, LOW);   
   
    mySerial.write(byteSend);
    delay(100);
  }// MySerialAvailable
  
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/


//*********( THE END )***********

