/* YourDuinoStarter Example:: Analog Value
 - Reads voltage on Analog Pin 0 and displays value
 - Converts integer value to volts and displays it
 - Turns LED ON/OFF depending on Analog Voltage
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
 - Potentiometer from +5 to Ground, center to pin A0
 - V1.02 02/11/13
 Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
//none
/*-----( Declare Constants and Pin Numbers )-----*/
#define analogPin  A0  // In separate group of pins
#define ledPin     13  // The onboard LED
/*-----( Declare objects )-----*/
//none
/*-----( Declare Variables )-----*/
int    analogIntValue;    // Holds the integer 10 bit value read in
float  analogVoltsValue;  // Value converted to 0..5V 


void setup()   /****** SETUP: RUNS ONCE ******/
{
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);   //Start sending to "Serial Monitor"
  Serial.println("YourDuinoStarter: Show Analog Value.");
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  Serial.println(); // Make a new line
/*---( Read and display the 10 bit integer value )------*/  
  analogIntValue = analogRead(analogPin); //Read value
  Serial.print("10 Bit Integer VALUE = ");
  Serial.print(analogIntValue,DEC); // Print value 
  
/*---( Convert and display the  0 to 5V value )------*/    
  analogVoltsValue = analogIntValue * (5.0 / 1024.0);
  Serial.print("    0 to 5V VALUE = ");
  Serial.println(analogVoltsValue, 3); // Print value   
 
/*-( Test the voltage. If it's greater than 3.0 turn on the LED )-*/    
  if (analogVoltsValue > 3.0) 
  {
    digitalWrite(ledPin, HIGH);
    Serial.println("Voltage > 3.0V LED turned ON");
  } 
  else
  {
    digitalWrite(ledPin, LOW);    
    Serial.println("Voltage <= 3.0V LED turned OFF");    
  }
  
  
  delay(2000);     // Wait 2 seconds
  
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
//none
//*********( THE END )***********


