/* YourDuinoStarter Example: BLINK without delay
 - WHAT IT DOES
   Turns on and off a light emitting diode(LED) connected to a digital
   pin, without using the delay() function.  This means that other code
   can run at the same time without being interrupted by the LED code.
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
   -  LED attached from pin 13 to ground.
   -  Note: on most Arduinos, there is already an LED on the board
      that's attached to pin 13, so no hardware is needed for this example.
       created 2005
    by David A. Mellis,  modified 8 Feb 2010 by Paul Stoffregen
    modified 11 Nov 2013  by Scott Fitzgerald, Annotated 12/13 by Terry King
   -
 - V1.00 12/04/2013
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
// none
/*-----( Declare Constants and Pin Numbers )-----*/
const int  ledPin   =  13;      // the number of the LED pin
const long interval = 1000;           // interval at which to blink (milliseconds)
/*-----( Declare objects )-----*/
// none
/*-----( Declare Variables )-----*/
int ledState = LOW;             // ledState used to set the LED
// Generally, you shuould use "unsigned long" for variables that hold time
// The value will quickly become too large for an int to store
unsigned long previousMillis = 0;        // will store last time LED was updated
unsigned long currentMillis  = 0;             // Will store the current time
void setup()   /****** SETUP: RUNS ONCE ******/
{
  pinMode(ledPin, OUTPUT);   // set the digital pin as output:
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  // HERE is where you'd put code that needs to be running all the time.

  //----( What you need to do every loop to blink the LED )----------
  // check to see if it's time to blink the LED:
  // Test IF the difference between the current time and last time you blinked
  // the LED is bigger than the interval at which you want to blink the LED.

  currentMillis = millis(); // Get the current time

  if (currentMillis - previousMillis >= interval) // Check if time is up
  { // IF Time is up, do the things inside these Brackets :

    previousMillis = currentMillis;   // save the last time you blinked the LED

    if (ledState == LOW)  // Change the variable with the State of the LED
      ledState = HIGH;
    else
      ledState = LOW;

    digitalWrite(ledPin, ledState);// set the LED with the ledState of the variable
  }// End of handling "Time is Up"

}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
// none
//*********( THE END )***********

