/* YourDuinoStarter Example: 
 - WHAT IT DOES: Red-Green-Blue LED fade between colors
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
   - Common Cathode (-) three-color LED such as RGB Electronic Brick
   - PINS: RED-9, GREEN-10, BLUE-11, Ground
 - V1.00 12/13/2013  Based on ideas from Matthew L Beckler 
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
//none
/*-----( Declare Constants and Pin Numbers )-----*/
#define redPin   9
#define greenPin 10
#define bluePin  11

/*-----( Declare objects )-----*/
//none
/*-----( Declare Variables )-----*/
int redVal;   // Hold the changing color values
int greenVal;
int blueVal;


void setup()   /****** SETUP: RUNS ONCE ******/
{
  redVal = 0;     // Start at black
  greenVal = 0;
  blueVal = 0;
  update();       // Apply those values
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  // start out at black (all off)
  color_morph(&redVal,   1); // transition to red
  color_morph(&greenVal, 1); // transition to yellow
  color_morph(&redVal,   0); // transition to green
  color_morph(&blueVal,  1); // transition to aqua
  color_morph(&redVal,   1); // transition to white
  color_morph(&greenVal, 0); // transition to violet
  color_morph(&redVal,   0); // transition to blue
  color_morph(&blueVal,  0); // transition to black (all off)
  delay(1000);

}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/

// This function updates the LED outputs.
void update()
{
  analogWrite(redPin, redVal);
  analogWrite(greenPin, greenVal);
  analogWrite(bluePin, blueVal);
}


// This function updates one of the color variables
// either getting brighter or getting dimmer.
// It also updates the outputs and delays for 10 milliseconds.
void color_morph(int* value, int get_brighter)
{
  for (int i = 0; i < 255; i++)
  {
    if (get_brighter)
      (*value)++;
    else
      (*value)--;
      
    update();
    delay(10);
  }
}


//*********( THE END )***********

