/* YourDuinoStarter Example: ServoButtons
 - WHAT IT DOES: Moves servo to two positions, based on 2 switches
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
   - Servo Pin 11
   - Switches pins 5,6
 - V1.00 12/17/2013
   Basied on example from zoomkat 12-29-2011
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <Servo.h>
/*-----( Declare Constants and Pin Numbers )-----*/
#define button1  5
#define button2  6
#define servopin    11
/*-----( Declare objects )-----*/
Servo servo1;
/*-----( Declare Variables )-----*/
int  Button1Pressed = 0;
int  Button2Pressed = 0;

void setup()   /****** SETUP: RUNS ONCE ******/
{
  pinMode(button1, INPUT);
  pinMode(button2, INPUT);  
  digitalWrite(button1, HIGH); //enable pullups to make pin high
  digitalWrite(button2, HIGH); //enable pullups to make pin high
  servo1.attach(servopin);

}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  Button1Pressed = digitalRead(button1);
  if (Button1Pressed == LOW)
  {
    servo1.write(170);
  }    
  
  Button2Pressed = digitalRead(button2);
  if (Button2Pressed == LOW)
  {
    servo1.write(10);
  }

}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
//none

//*********( THE END )***********

