/* YourDuino Electronic Brick Test 3
 Simple Switch type INPUT DEVICES
 INTRUDER ALARM
 with Serial Monitor Output
 terry@yourduino.com */

/*-----( Declare Constants )-----*/
#define SWITCHPIN      3
#define LEDPIN        11
#define BUZZERPIN     10

/*-----( Declare Variables )-----*/
int  switch_state;  /* Holds the last state of the switch */
int  buzzer_state;  /* Buzzer ON or OFF */

void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  pinMode(LEDPIN, OUTPUT);
  pinMode(BUZZERPIN, OUTPUT);
  buzzer_state = false;    
  Serial.begin(9600);

}/*--(end setup )---*/


void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{
  Serial.print("ALARM IS - ");
  switch_state = digitalRead(SWITCHPIN);  
  if (switch_state == HIGH)
  {
    digitalWrite(LEDPIN, HIGH);    
    Serial.println("GOING OFF ! !");

    buzzer_state = ! buzzer_state;
    if (buzzer_state == 1) 
    {
      digitalWrite(BUZZERPIN, HIGH);  
    }
    else  
    {
      digitalWrite(BUZZERPIN, LOW);  
    }    
  }  
  else /* The switch is OFF */
  {
    digitalWrite(LEDPIN, LOW);
    digitalWrite(BUZZERPIN, LOW);  
    buzzer_state = false;  
    Serial.println("NOT ACTIVE");    
  }
  delay(250); /* Wait a bit to see display and listen to buzzer*/
}/* --(end main loop )-- */

/* ( THE END ) */
