// accellsteppertest.ino
// Runs two steppers forwards and backwards, accelerating and decelerating
// at the limits. Derived from example code by Mike McCauley
// modified by Celem for single stepper
// Set for two 28BYJ-48 stepper motors

#include <AccelStepper.h>

#define FULLSTEP 4
#define HALFSTEP 8

//declare variables for the motor pins
int motorPin1 = 4;	// Blue   - 28BYJ48 pin 1
int motorPin2 = 5;	// Pink   - 28BYJ48 pin 2
int motorPin3 = 6;	// Yellow - 28BYJ48 pin 3
int motorPin4 = 7;	// Orange - 28BYJ48 pin 4
                        // Red    - 28BYJ48 pin 5 (VCC)
int motorPin5 = 8;	// Blue   - 28BYJ48 pin 1
int motorPin6 = 9;	// Pink   - 28BYJ48 pin 2
int motorPin7 = 10;	// Yellow - 28BYJ48 pin 3
int motorPin8 = 11;	// Orange - 28BYJ48 pin 4
                        // Red    - 28BYJ48 pin 5 (VCC)
// The sequence 1-3-2-4 required for proper sequencing of 28BYJ48
AccelStepper stepper1(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);
AccelStepper stepper2(HALFSTEP, motorPin5, motorPin7, motorPin6, motorPin8);

void setup()
{ 
  stepper1.setMaxSpeed(1000.0);
  stepper1.setAcceleration(50.0);
  stepper1.setSpeed(200);
  stepper1.moveTo(2048);   
  
  stepper2.setMaxSpeed(1000.0);
  stepper2.setAcceleration(50.0);
  stepper2.setSpeed(200);
  stepper2.moveTo(2048);
}

void loop()
{
  //Change direction at the limits
  if (stepper1.distanceToGo() == 0) 
    stepper1.moveTo(-stepper1.currentPosition());
    if (stepper2.distanceToGo() == 0) 
    stepper2.moveTo(-stepper2.currentPosition());
  
  stepper1.run();
  stepper2.run();
}
