 
/* CABIN Model 6 
 - WHAT IT DOES: Read OPTO22 Inputs, Set OPTO22 Outputs
 - Testing StopWatchTimers
 - Testing Oley TTS
 - CONNECTIONS:
 - Opto22 DI Mega 38 .. 53
 - Opto22 DO Mega 22 .. 37
 - V2.10 09/04/13
 Questions: terry@yourduino.com */

//***********( ENABLE/DISABLE DEBUG MESSAGES )*****************
//#define DEBUG
#include <DebugUtils.h>
// Then simply use DEBUG_PRINT("message"); to print your debugging message. 
// Or if you don't want the debug messages to appear simply comment out the DEBUG definition


//****************( Include Needed libraries )************************************
#include <Wire.h>      // I2C Communications Library
//#include <RealTimeClockDS1307.h>  //DS1307 Real Time Clock
#include "RTClib.h"
#include <SoftwareSerial.h>  // For communication to Emic2 Text-To-Speech module
// Module from http://www.grandideastudio.com/portfolio/emic-2-text-to-speech-module/ 
// (Sold by Parallax and Sparkfun.com)

#include <StopWatch.h>  // Rob's StopWatch Library

#include <avr/pgmspace.h>    // For Morse Decoder
// This library from:   http://raronoff.wordpress.com/2010/12/16/morse-endecoder/
#include <MorseEnDecoder.h>

// Get 1-wire Library here: http://www.pjrc.com/teensy/td_libs_OneWire.html
#include <OneWire.h>

//Get DallasTemperature Library here:  http://milesburton.com/Main_Page?title=Dallas_Temperature_Control_Library
#include <DallasTemperature.h>


//************************( Declare Constants and Pin Numbers )*************************
#include "iodoc.h"  // This is the TAB "iodoc.h"

//***********************( Declare Variables )*************************************
#include "Variables.h"  // This is the TAB "Variables.h"

//**************************( Declare Instances of Library objects )**********************************
morseDecoder morseInput(morseInPin, MORSE_KEYER, MORSE_ACTIVE_LOW);

SoftwareSerial emicSerial =  SoftwareSerial(TTSrxPin, TTStxPin);

RTC_DS1307 RTC;

// Create instances of StopWatch Timers
StopWatch TestTimer;
StopWatch WaterHeaterTimer;
StopWatch GasBurnerTimer;
StopWatch MainHeatZoneTimer;
StopWatch WaterPumpTimer;
StopWatch ShowerTimer;
StopWatch PlantWaterTimer;
StopWatch SolarHeaterTimer;
StopWatch DishWasherTimer;
StopWatch PhoneTimer;


void setup()   /************************** SETUP: RUNS ONCE *****************************/
{
  DEBUG_PRINT("SETUP");
  
  TestTimer.start();
  
  //-----( SET UP Digital Outputs: First set HIGH (Inactive), then pinMode Output )--------
  InitDigitalOutputs();
 
  Wire.begin();        // Start the Wire (I2C communications)

//  Serial.begin(9600); 
  Serial.begin(115200);   
  delay(10);
  Serial.println("OLEYIII Cabin Control 3.03");  
  //-----( SET UP MORSE DECODE )--------
  morseInput.setspeed(5);  // 5 words per minute : slow  


  //-----( SET UP Text-To-Speech )-----------
  pinMode(TTSrxPin, INPUT);
  pinMode(TTStxPin, OUTPUT);
   
   Serial1.begin(9600);             // set the data rate for the SoftwareSerial port
   Serial1.print('\n');             // Send a CR in case the system is already up
   while (Serial1.read() != ':');   // When the Emic 2 has initialized and is ready, it will send a single ':' character, so wait here until we receive it
   delay(10);                          // Short delay
 
   Serial1.print("S  System Started. This is Oh Lee.\n");  // Send a string to convert to speech  
   TTS_Ready = false; 
  


 // Say("Hello Terry. What's up?\0");

}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  //-------( GetTime:  From RealTime Clock )-------------------------   
  GetTime();  

  //-------( CheckSensors: Reads Digital Inputs.  Maybe read Temperatures? )-----------------------
  CheckSensors();  

  //-------( GetHumanInput: Reads Morse, Checks communications interfaces )-----------------------
  GetHumanInput();  

  //-------( ProcessCommands: Changes MODES, SAYS or Displays requested data )--------------------
  ProcessCommands();  

  //-------( ProcessSchedule: Modifies MODES depending on real time/date )--------------------
  ProcessSchedule(); 

  //-------( ProcessMonitors: Checks physical variables and Digital IN against limits, sets MODES. )----
  // ProcessMonitors(); 

  //-------( ExecuteModeChanges: Changes logical or physical MODES. Sets digital I/O points. )------
   ExecuteModeChanges(); 



  // Serial.println("-------------( END MAIN LOOP )---------");  
  if (TTS_Ready) 
  {  
  digitalWrite(13,HIGH);
  } 
  else 
  {  
  digitalWrite(13,LOW);
  }
  //delay(10 );
//  digitalWrite(13,LOW);  
  receivedMorse = '&';  // Unrecognized until next human input


//  Serial.println(TestTimerElapsedTimeMS);
  
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
// NOTE: Functions now on Tabs

//*********( THE END )***********



