void ExecuteModeChanges() 
{
  DEBUG_PRINT("Executing Mode Changes");
//  Execute actions based on MODE changes. Update ON and OFF status.
//  ExecuteModeChanges PROCEDURE: Logical and Physical actions from Modes 

/*  EXAMPLES:

       {-----( GasHeatMODE )--------------------}
    IF GasHeatMODE and NOT GasHeatON
     THEN
      BEGIN
        GasHeatON    := TRUE;
        TurnOn(GasBurnEnab);
        RC:=SayLow('Gas Burner enabled.');
      END;

    IF NOT GasHeatMODE and GasHeatON
     THEN
      BEGIN
        GasHeatON    := FALSE;
        TurnOff(GasBurnEnab);
        RC:=SayLow('Gas Burner disabled.');
      END;
      
*/      
     

//      {-----( PoolLights MODE )--------------------} About 75 bytes
    if (   PoolLightsMODE
       && ! PoolLightsON)
       {
         PoolLightsON = TRUE;
         TurnOn(DO_PoolLights);
       }   
       
    if (  ! PoolLightsMODE
       &&  PoolLightsON)
       {
         PoolLightsON = FALSE;
         TurnOff(DO_PoolLights);
       }          

//      {-----( OutDoorLights MODE )--------------------} About 75 bytes
    if (    OutDoorLightsMODE
       && ! OutDoorLightsON)
       {
         OutDoorLightsON = TRUE;
         TurnOn(DO_OutdoorLights);
       }   
       
    if (  ! OutDoorLightsMODE
       &&   OutDoorLightsON)
       {
         OutDoorLightsON = FALSE;
         TurnOff(DO_OutdoorLights);
       }          
       
//      {-----( WaterHeaterMODE )--------------------} About 75 bytes
    if (  WaterHeaterMODE
       && ! WaterHeaterON)
       {
         WaterHeaterON = TRUE;
         TurnOn(DO_WaterHeater);
       }   
       
    if (  ! WaterHeaterMODE
       &&   WaterHeaterON)
       {
         WaterHeaterON = FALSE;
         TurnOff(DO_WaterHeater);
       }          
              
       
}// End ExecuteModeChanges


