#include <SPI.h>
#include <Ethernet.h>
#include <HttpClient.h>
#include <Cosm.h>

// #define API_KEY "r5LAQylJnH2_S05o1t8yi1yxBtiSAKxxSmpJR0orTTVlbz0g" // your Cosm API key
// #define FEED_ID 96891 // your Cosm feed ID
// Location of the libraries need for Cosm to work
// Cosm Arduino lib : https://github.com/mnin/CosmArduino
// HttpClient lib : https://github.com/amcewen/HttpClient


// MAC address for your Ethernet shield
// Change this if you have more than one Eth Shield on your network
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

// Change this to your Cosm key to let you upload data
// The API Key are located at https://cosm.com/users/<cosm_username>/keys
char cosmKey[] = "r5LAQylJnH2_S05o1t8yi1yxBtiSAKxxSmpJR0orTTVlbz0g";

// Define the strings for our datastream IDs
// Create the 4 feeds
char sensorId[] = "Int1";
char sensorId2[] = "Int2";
char sensorId3[] = "Float1";
char sensorId4[] = "Float2";

// DATASTREAM_INT = integer
// DATASTREAM_FLOAT = float

CosmDatastream datastreams[] = {
  CosmDatastream(sensorId, strlen(sensorId), DATASTREAM_INT),  // define this ID in cosm
  CosmDatastream(sensorId2, strlen(sensorId), DATASTREAM_INT), // define this ID in cosm
  CosmDatastream(sensorId3, strlen(sensorId), DATASTREAM_FLOAT), // define this ID in cosm
  CosmDatastream(sensorId4, strlen(sensorId), DATASTREAM_FLOAT), // define this ID in cosm
};

// Finally, wrap the datastreams into a FeedID, change this
CosmFeed feed(96891, datastreams, 4 );  // Using 4 feeds with FeedID of 96891, get from cosm

// I use static IP address for easy troubleshooting
IPAddress ip(192,168,1,122);             // Static IP address

EthernetClient client;
CosmClient cosmclient(client);
 
void setup(){      
   
   Serial.begin(9600);
  
   Serial.println("Starting single datastream upload to Cosm...");
// Setting up Ethernet static IP address 
   Serial.println("Starting Ethernet Client...");
   Ethernet.begin(mac, ip);
   Serial.println("Ethernet client & IP address OK");  

   delay(1000);
}
 
void loop()
{
  int   A,B;             // Change to your sensor variable names
  float C,D;             // Change to your sensor variable names  
  int cosmReturn = 0;
  
  // Put your sensor input code here
  A = 10;
  B = 20;
  C = 40.12;
  D = 80.24;
  
  
  // Put sensor values into the 4 datastreams,
  // setInt() for integer
  // setFloat() for floating point
  datastreams[0].setInt(A);    // Set sensor values into datastreams 1
  datastreams[1].setInt(B);    // Set sensor values into datastreams 2
  datastreams[2].setFloat(C);    // Set sensor values into datastreams 3
  datastreams[3].setFloat(D);    // Set sensor values into datastreams 4
  
  
  // getInt for integer, getFloat for floating point
  Serial.print("A:");
  Serial.println(datastreams[0].getInt());  // Print datastream to serial monitor
  Serial.print("B:");
  Serial.println(datastreams[1].getInt());  // Print datastream to serial monitor
  Serial.print("C:");
  Serial.println(datastreams[2].getFloat());  // Print datastream to serial monitor
  Serial.print("D:");
  Serial.println(datastreams[3].getFloat());  // Print datastream to serial monitor
  
  // This line send the feed to cosm, while testing/debugging your codes, comment it out
   cosmReturn = cosmclient.put(feed,cosmKey);   // Send feed to cosm

   Serial.print("COSM client returned : "); // Get retern code, similar to HTTP code
   Serial.println(cosmReturn);
  
  delay(2000); // Put a delay before the next updates to Cosm
} 
