#include <OneWire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS_PIN 2

// Setup a oneWire instance to communicate with any OneWire devices
OneWire oneWire(ONE_WIRE_BUS_PIN);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);

// Assign the addresses of your 1-Wire temp sensors.
// See the tutorial on how to obtain these addresses:
// http://www.hacktronics.com/Tutorials/arduino-1-wire-address-finder.html

// YourDuino DS18B20 Brick 1
DeviceAddress Probe012 = { 0x28, 0xC7, 0x3C, 0xB3, 0x03, 0x00, 0x00, 0x5C };

// "Octopus" Brick1
DeviceAddress Probe013 = { 0x28, 0xC4, 0xDD, 0x89, 0x04, 0x00, 0x00, 0x3B};

/*  
DeviceAddress Probe014 = { 
  0x28, 0x30, 0x65, 0x31, 0x03, 0x00, 0x00, 0x13 };
DeviceAddress Probe015 = { 
  0x28, 0xDE, 0x9D, 0x31, 0x03, 0x00, 0x00, 0xB1 };
DeviceAddress Probe016 = { 
  0x28, 0x7E, 0x8A, 0x31, 0x03, 0x00, 0x00, 0xC0 };
*/

void setup(void)
{
  // start serial port
  Serial.begin(9600);
  // Start up the library
  sensors.begin();
  // set the resolution to 10 bit (good enough?)
  sensors.setResolution(Probe012, 10);

  sensors.setResolution(Probe013, 10);
/*    
  sensors.setResolution(Probe014, 10);
  sensors.setResolution(Probe015, 10);
  sensors.setResolution(Probe016, 10);
  */
}

void loop(void)
{
  delay(2000);
  Serial.println();
  Serial.println();  
  Serial.print("Getting temperatures... ");  
  sensors.requestTemperatures();  
  
  Serial.print("Probe 012 temperature is:   ");
  printTemperature(Probe012);
  Serial.println();
  
  Serial.print("Probe 013 temperature is:   ");
  printTemperature(Probe013);
  Serial.println();
/*  
  Serial.print("Probe 014 temperature is:   ");
  printTemperature(Probe014);
  Serial.println();
  
  Serial.print("Probe 015 temperature is:   ");
  printTemperature(Probe015);
  Serial.println();
  
  Serial.print("Probe 016 temperature is:   ");
  printTemperature(Probe016);
  Serial.println();
*/  
   
  
}

void printTemperature(DeviceAddress deviceAddress)
{

float tempC = sensors.getTempC(deviceAddress);

   if (tempC == -127.00) 
   {
   Serial.print("Error getting temperature  ");
   } 
   else
   {
   Serial.print("C: ");
   Serial.print(tempC);
   Serial.print(" F: ");
   Serial.print(DallasTemperature::toFahrenheit(tempC));
   }
}


