/* SHED Magazine Arduino Sketch: Analog Value
 - Reads voltage on Analog Pin 0 and displays value
 - Converts integer value to volts and displays it
 - SEE the comments after "//" on each line below
 - CONNECTIONS:
 - Potentiometer from +5 to Ground, center to pin A0
 - V1.01 09/11/12
 Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
//none
/*-----( Declare Constants and Pin Numbers )-----*/
#define analogPin  A0  // In separate group of pins
#define ledPin     13  // The onboard LED
/*-----( Declare objects )-----*/
//none
/*-----( Declare Variables )-----*/
int    analogIntValue;    // Holds the integer 10 bit value read in
float  analogVoltsValue;  // Value converted to 0..5V 


void setup()   /****** SETUP: RUNS ONCE ******/
{
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);   //Start sending to "Serial Monitor"
  Serial.println("SHED Magazine: Show Analog Value.");
}//--(end setup )---


void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
/*---( Read and display the 10 bit integer value )------*/  
  analogIntValue = analogRead(analogPin); //Read value
  Serial.print("10 Bit Integer VALUE = ");
  Serial.print(analogIntValue,DEC); // Print value 
  
/*---( Convert and display the  0 to 5V value )------*/    
  analogVoltsValue = analogIntValue * (5.0 / 1024.0);
  Serial.print(" 0 to 5V VALUE = ");
  Serial.println(analogVoltsValue, 3); // Print value   
  
  delay(1000);     // Wait 1 second
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
//none
//*********( THE END )***********


