/* YourDuino SKETCH TEMPLATE 
 Start with this for most 
 more-complex Arduino Sketches
 terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include "Timer.h"

/*-----( Declare Constants and Pin Numbers )-----*/
#define LED1pin 13
#define LED2pin 11

/*-----( Declare objects )-----*/
Timer timerAction;

/*-----( Declare Variables )-----*/
int  state;
boolean LED1_STATE;
boolean LED2_STATE;
boolean timer1Expired = false;
boolean timer2Expired = false;
boolean EventTimer1   = false;
boolean EventTimer2   = false;

void setup()   /****** SETUP: RUNS ONCE ******/
{

  Serial.begin(9600);
  Serial.println("StateTest1 Started");
  pinMode(LED1pin, OUTPUT);  
  pinMode(LED2pin, OUTPUT);    
  timerAction.every(500, Timer1);
  timerAction.every(1800, Timer2);  


}//--(end setup )---

/*-----------------------------------------------------------------------*/
void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  timerAction.update();
  CheckTimerEvents();
  CheckSensors();
  MakeDecisions();
  TakeActions();
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/

/*-----------------------------------------------------------------------*/
void Timer1()
{
//  Serial.println("----------------Timer1 called");
  timer1Expired = true;
}
/*-----------------------------------------------------------------------*/
void Timer2()
{
//  Serial.println("---------------Timer2 called");
  timer2Expired = true;
}
/*-----------------------------------------------------------------------*/
void CheckTimerEvents()
{
//  Serial.println("Checktimers");
  if (timer1Expired == true)
  { 
//    Serial.println("Checktimers Event1");    
    EventTimer1 = true;
    timer1Expired = false;
  }

  if (timer2Expired == true)
  { 
//    Serial.println("Checktimers Event2");        
    EventTimer2 = true;
    timer2Expired = false;
  }  
}// End CheckTimerEvents


/*-----------------------------------------------------------------------*/
void  CheckSensors()
{
}// End CheckSensors


/*-----------------------------------------------------------------------*/
void  MakeDecisions()
{
  state = 0;
  if (EventTimer1 == true) state = 1; 
  if (EventTimer2 == true) state = 2;  
  

  switch (state)
  {
  case 1:
    Serial.println("State 1"); 
    LED1_STATE = !LED1_STATE;
    EventTimer1 = false;   
    break;
    
  case 2:
    Serial.println("State 2");  
    LED2_STATE = !LED2_STATE;    
    EventTimer2 = false;     
    break;
    
  default: {}

  }// End Switch  
  
}// End MakeDecisions 

/*-----------------------------------------------------------------------*/
void  TakeActions()
{
  
       digitalWrite(LED1pin, LED1_STATE);  
       digitalWrite(LED2pin, LED2_STATE);     
  
}// End TakeActions

//*********( THE END )***********


