/* YourDuino.com Example Software Sketch
   Small Stepper Motor and Driver V2.0 12/20/2013
   http://arduino-direct.com/sunshop/index.php?l=product_detail&p=126
   Steps one revolution of output shaft (2048 steps), waits,repeats
   in the same direction. This will show that the motor advances a little
   more than one revolution with 2048 (4-step sequence) steps. This means
   that the mechanical gear ratio is NOT exectly 64:1 but more like
   63.68395.:1  
   Questions: terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <Stepper.h>

/*-----( Declare Constants, Pin Numbers )-----*/
//---( Number of steps per revolution of INTERNAL motor in 4-step mode )---
#define STEPS_PER_MOTOR_REVOLUTION 32

//---( Steps per OUTPUT SHAFT of gear reduction )---
#define STEPS_PER_OUTPUT_REVOLUTION 32 * 64  //2048  


/*-----( Declare objects )-----*/
// create an instance of the stepper class, specifying
// the number of steps of the motor and the pins it's
// attached to

//The pin connections need to be 4 pins connected
// to Motor Driver In1, In2, In3, In4  and then the pins entered
// here in the sequence 1-3-2-4 for proper sequencing
Stepper small_stepper(STEPS_PER_MOTOR_REVOLUTION, 8, 10, 9, 11);

/*-----( Declare Variables )-----*/
int  Steps2Take;
int  TotalRevolutions = 0 ;

void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  Serial.begin(9600);
  Steps2Take  =  STEPS_PER_OUTPUT_REVOLUTION ;  // Rotate CW 1 turn
  small_stepper.setSpeed(500);
}/*--(end setup )---*/

void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{

  small_stepper.step(Steps2Take);
  TotalRevolutions += 1;  // Count revolutions
  Serial.print("Total Revolutions = ");  
  Serial.println(TotalRevolutions,DEC);

  delay(2000);

}/* --(end main loop )-- */

/* ( THE END ) */
