/* Standard Starter Template: Arduino  terry@terryking.us */
/*     The circuit:
 * potentiometers attached to analog inputs 0 and 1 
 * pushbutton attached to digital I/O 2
*/
/*-----( Declare Constants )-----*/

/*-----( Declare Variables )-----*/
int firstSensor = 0;    // first analog sensor
int secondSensor = 0;   // second analog sensor
int thirdSensor = 0;    // digital sensor
int inByte = 0;         // incoming serial byte
/****** SETUP: RUNS ONCE ******/
void setup()
{
  pinMode(13, OUTPUT);  // For SendData Blip
  // start serial port at 9600 bps:
  Serial.begin(9600);
  pinMode(2, INPUT);   // digital sensor is on digital pin 2
  establishContact();  // send a byte to establish contact until receiver responds 
}//--(end setup )---

/****** LOOP: RUNS CONSTANTLY ******/
void loop()
{
  // if we get a valid byte, read analog ins:
  if (Serial.available() > 0) 
  {
    digitalWrite(13, HIGH); 
    // get incoming byte:
    inByte = Serial.read();
    // read first analog input, divide by 4 to make the range 0-255:
    firstSensor = analogRead(A0)/4;
    // delay 10ms to let the ADC recover:
    delay(10);
    // read second analog input, divide by 4 to make the range 0-255:
    secondSensor = analogRead(1)/4;
    // read  switch, map it to 0 or 255L
    thirdSensor = map(digitalRead(2), 0, 1, 0, 255);  
    // send sensor values:
    Serial.print(firstSensor, BYTE);
    Serial.print(secondSensor, BYTE);
    Serial.print(thirdSensor, BYTE);    
    delay(30); 
    digitalWrite(13, LOW); //Blip each transaction
    delay(30);     
  }
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/
void establishContact() 
{
  while (Serial.available() <= 0) 
  {
    Serial.print('A', BYTE);   // send a capital A
    delay(300);
  }
}//end establishContact()


