//http://www.arduino.cc/playground/uploads/Code/FSM.zip
#include <FiniteStateMachine.h> 
//http://www.arduino.cc/playground/uploads/Code/Button.zip
#include <Button.h>
//http://www.arduino.cc/playground/uploads/Code/LED.zip
#include <LED.h>
 
const byte NUMBER_OF_STATES = 4; //how many states are we cycling through?
 
//initialize states
State On = State(ledOn);
State Off = State(ledOff);
State FadeIn = State(ledFadeIn);
State FadeOut = State(ledFadeOut);
 
FSM ledStateMachine = FSM(On);     //initialize state machine, start in state: On
 
Button button = Button(11,PULLUP); //initialize the button (wire between pin 12 and ground)
LED led = LED(5);                 //initialize the LED
byte buttonPresses = 0;            //counter variable, hols number of button presses
 
void setup()
{ 
 Serial.begin(9600); 
 Serial.println("Start"); 
}
 
//poor example, but then again; it's just an example
void loop(){
  if (button.isPressed()){
    //increment buttonPresses and constrain it to [ 0, 1, 2, 3 ]
    buttonPresses = ++buttonPresses % NUMBER_OF_STATES;
    Serial.print("ButtonPresses = ");
    Serial.println(buttonPresses);
    switch (buttonPresses){
      case 0: ledStateMachine.transitionTo(On); break;
      case 1: ledStateMachine.transitionTo(Off); break;
      case 2: ledStateMachine.transitionTo(FadeIn); break;
      case 3: ledStateMachine.transitionTo(FadeOut); break;
    }
  }
  ledStateMachine.update();
}
 
//utility functions
void ledOn(){ led.on(); }
void ledOff(){ led.off(); }
void ledFadeIn(){ led.fadeIn(2500); }
void ledFadeOut(){ led.fadeOut(2500); }
//end utility functions
