/* this sketch will help you figure out the individual buttons for a 5 button keypad,
 this was a combination of the "LCD_button_shield" sketch from 
 yourduino.com and the "ReadAnalogVoltage"
 from the arduino IDE.
 "randy ..." <astralk@hotmail.com>
 */

/*------( declare Constants )--------*/
#define button1   0
#define button2   1
#define button3   2
#define button4   3
#define button5   4


/* AD_Key and buttons mean the same thing! */


/*--------( declare Variables )--------*/
int AD_Key       = 0; //keypad button value
int AD_Key_in    = 0; //keypad button value when a button is pushed
int AD_Key_prev  = 0; // a previous button value that was already pushed

void setup() 
{
  Serial.begin(9600);
  Serial.println("push a button!");
}


void loop() {

  AD_Key_prev = AD_Key; //the previous keypad button is now the new keypad button
  AD_Key      = read_AD_Key_buttons(); //send the keypad button value to "read_AD_Key_buttons()" sub-program (at the bottom of the page)

  if(AD_Key_prev != AD_Key) {   //if the previous keypad button does NOT equal(is not the same) as the button being pressed
    Serial.println(AD_Key_in); //print the value of the keypad button
  }

  switch(AD_Key) 
  {
  case button1:
    {
      Serial.println("button 1");
      break;
    }
  case button2:
    {
      Serial.println("button 2");
      break;
    }
  case button3:
    {
      Serial.println("button 3");
      break;
    }
  case button4:
    {
      Serial.println("button 4");
      break;
    }
  case button5:
    {
      Serial.println("button 5");
      break;
    }

  } //end switch
} //end main loop



/*-----( Declare User-written Functions )-----*/

int read_AD_Key_buttons() {
  AD_Key_in = analogRead(0); //reads value from analog pin 0
  delay(5); //switch debounce delay. increase this if incorrect switch selections are returned
  int k = (analogRead(0) - AD_Key_in); //gives the button a slight range to allow for a little contact resistance noise

  /* the easiest way to find the voltage/value of each button is to use the "ReadAnalogVoltage" sketch found
   in the examples>basics, then write down the values of your keypad buttons on paper to use
   in the section below. */


  if(AD_Key_in > 0   && AD_Key_in < 200)        return button1; //my real value was 176 from the examples sketch
  if(AD_Key_in >= 200 && AD_Key_in < 450)       return button2; //"   "     "    "  405
  if(AD_Key_in >= 450 && AD_Key_in < 800)       return button3; //"   "     "    "  767
  if(AD_Key_in >= 800 && AD_Key_in < 960)       return button4; //"   "     "    "  953
  if(AD_Key_in >= 960 && AD_Key_in <= 1023)     return button5; //"   "     "    "  1023 

}
/*-----( THE END )-----*/






