
/* YourDuinoStarter Example: MMA7455 Accelerometer Test
  This example uses the MMA_7455 library by Moritz Kemper  moritz.kemper@zhdk.ch
  Released under Creative Commons Licence
 - V1.00 11/16/2013
   Questions: terry@yourduino.com  
   
/*-----( Import needed libraries )-----*/
#include <Wire.h> //Include the Wire library
#include <MMA_7455.h> //Include the MMA_7455 library

/*-----( Declare Constants and Pin Numbers )-----*/

/*-----( Declare objects )-----*/
MMA_7455 mySensor = MMA_7455(); //Make an instance of MMA_7455

/*-----( Declare Variables )-----*/
char xVal, yVal, zVal; //Variables for the values from the sensor

void setup()   /****** SETUP: RUNS ONCE ******/
{
  Serial.begin(9600);
  delay(500);
  Serial.println("MMA7455 Accelerometer Test. terry@yourduino.com");
  // Set the sensitivity you want to use
  // 2 = 2g, 4 = 4g, 8 = 8g
  mySensor.initSensitivity(2);
  // Calibrate the Offset, that values corespond in 
  // flat position to: xVal = -30, yVal = -20, zVal = +20
  // !!!Activate this after having the first values read out!!!
  //mySensor.calibrateOffset(0.23, -43.2, 12.43);
}//--(end setup )---

void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  xVal = mySensor.readAxis('x'); //Read out the 'x' Axis
  yVal = mySensor.readAxis('y'); //Read out the 'y' Axis
  zVal = mySensor.readAxis('z'); //Read out the 'z' Axis
  Serial.print("X = ");
  Serial.print(xVal, DEC);
  Serial.print(" Y = ");
  Serial.print(yVal, DEC);
  Serial.print(" Z = ");
  Serial.println(zVal, DEC);
  delay(1000);
}//--(end main loop )---

/*-----( Declare User-written Functions )-----*/


//*********( THE END )***********
