#include <SoftwareServo.h>

#define SERVO_1_PIN  3
#define SERVO_2_PIN  5

SoftwareServo servo1;
SoftwareServo servo2;

void setup()
{
  pinMode(13,OUTPUT);
  servo1.attach(SERVO_1_PIN);
  servo1.setMaximumPulse(2200);
  servo2.attach(SERVO_2_PIN);
  servo2.setMaximumPulse(2200);
  Serial.begin(9600);
  Serial.print("Ready");
}

void loop()
{
  static int value = 0;
  static char CurrentServo = 0;

  if ( Serial.available()) {
    char ch = Serial.read();
    switch(ch) {
      case 'A':
        servo1.attach(SERVO_1_PIN);
        CurrentServo='A';
        digitalWrite(13,LOW);
        break;
      case 'B':
        servo2.attach(SERVO_2_PIN);
        CurrentServo='B';
        digitalWrite(13,HIGH);
        break;
      case '0' ... '9':
        value=(ch-'0')*20;
        if (CurrentServo=='A')
        {
          servo1.write(value);
        }
        else if (CurrentServo=='B')
        {
          servo2.write(value);
        }
        break;
    }
  }
  SoftwareServo::refresh();
}
