/*  Arduino Driver Library for YourDuino.com RP-030320 L298N Motor Driver Board
    Questions?? terry@yourduino.com
	V1.03   10/09/13
*/
#ifndef A_YD_L298N_MotorDriver_h
#define A_YD_L298N_MotorDriver_h
/*--------( Include the correct Arduino definitions file, for Arduino1.0 or earlier versions)----*/
#if (ARDUINO >= 100)
#include <Arduino.h>
#else
#include <WProgram.h>
#endif

class A_YD_L298N_MotorDriver
{
  public:  
    // CONSTRUCTORS
    A_YD_L298N_MotorDriver(); // Default pins
    A_YD_L298N_MotorDriver(unsigned char INA1, unsigned char INB1, unsigned char INA2, unsigned char INB2); // Pin Options 
    
    // PUBLIC METHODS
    void init(); // Set up TIMER 1, set the PWM to 20kHZ
    void Motor1Speed(int speed); // Set speed for Motor1 (0..400)  
    void Motor2Speed(int speed); // Set speed for Motor2 (0..400) 
    void Motor1Brake(int brake); // Brake Motor1 (0..400)
    void Motor2Brake(int brake); // Brake Motor2 (0..400)
    
  private:
    unsigned char _INA1;
    unsigned char _INB1;
    static const unsigned char _PWM1 = 9;  // Can not be changed by user
    unsigned char _INA2;
    unsigned char _INB2;
    static const unsigned char _PWM2 = 10; // Can not be changed by user
    
}; // End Class

#endif