/* YourDuino.com Example Software Sketch
 A_YD_L298N_MotorDriver Library Test
 Questions?? terry@yourduino.com */

/*-----( Import needed libraries )-----*/
#include <A_YD_L298N_MotorDriver.h>

/*-----( Declare Constants )-----*/
// NOTE: Pins 9 (PWM for Motor1) and 10 (PWM for Motor2) are predefined, and unchangeable
#define  Motor1A  2   // Motor pins to Driver board
#define  Motor1B  4
#define  Motor2A  7
#define  Motor2B  8

#define  RampDelay  10

/*-----( Declare objects )-----*/
A_YD_L298N_MotorDriver RobotDriver(Motor1A,Motor1B,Motor2A,Motor2B);

/*-----( Declare Variables )-----*/


void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  Serial.begin(9600);
  Serial.println("YourDuino MotorDriver1 Ramp Up / Down Test");
  RobotDriver.init();

}/*--(end setup )---*/


void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{
  delay(5000); //Time to put a Robot down...
  
/*----( Ramp Motor1 Up and Down both directions )-------*/  
  for (int i = 0; i <= 400; i++)
  {
    RobotDriver.Motor1Speed(i);
    delay(RampDelay);
  }  
  
  for (int i = 400; i >= -400; i--)
  {
    RobotDriver.Motor1Speed(i);
    delay(RampDelay);
  } 

  for (int i = -400; i <= 0; i++)
  {
    RobotDriver.Motor1Speed(i);
    delay(RampDelay);
  } 


  
/*----( Ramp Motor2 Up and Down both directions )-------*/  
  for (int i = 0; i <= 400; i++)
  {
    RobotDriver.Motor2Speed(i);
    delay(RampDelay);
  }  
  
  for (int i = 400; i >= -400; i--)
  {
    RobotDriver.Motor2Speed(i);
    delay(RampDelay);
  } 

  for (int i = -400; i <= 0; i++)
  {
    RobotDriver.Motor2Speed(i);
    delay(RampDelay);
  } 

}/* --(end main loop )-- */

/*-----( Declare User-written Functions )-----*/


/* ( THE END ) */
